### Method

# FwupdPlugin UdevDevice set_physical_id

since: 1.1.2

#### Declaration [src]

    gboolean
    fu_udev_device_set_physical_id (
      FuUdevDevice* self,
      const gchar* subsystems,
      GError** error
    )

#### Description [src]

Sets the physical ID from the device subsystem. Plugins should choose the subsystem that is “deepest” in the udev tree, for instance choosing `usb` over `pci` for a mouse device.

The devtype can also be specified for a specific device, which is useful when the subsystem alone is not enough to identify the physical device. e.g. ignoring the specific LUNs for a SCSI device.

Available since: 1.1.2

#### Parameters

`subsystems`

  Type: `const gchar*`

  A subsystem string, e.g. `pci,usb,scsi:scsi_target`.

  The data is owned by the caller of the method.
  The value is a NUL terminated UTF-8 string.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the method if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `gboolean`

`TRUE` if the physical device was set.